program transfer;

{
  Aus CT 02.89, Seite 138-139
  angepasst fuer CPM 3.x auf Ct180.

  A.K. 01.01.91

  Achtung !!!
  Realtime-Clock muss vorhanden sein!
}

const
  vers           = 'Transfer, Version 2.12a, 3.12.88 CT / 07.90 A.K.';
  laenge         = 128;
  anzahl_saetze  = 250;
  anzahl_bloecke = 30;

  piodat         = $20;
  piost          = $22;
  piomod         = $0f;
  uhrdat         = $24;

var
  i,j            : integer;
  puffer         : array [1..laenge,1..anzahl_saetze] of byte;
  datei          : file;
  filename       : string[64];
  drv_path       : string[4];
  antwort        : char;
  ta,te,td,
  anz_byte,
  rate,laen,
  an_saet        : real;
  an_bloeck      : integer;
  h,m,s,hs       : byte;

  Day,Mon,Year,Hrs,Min,Sec :Byte;


PROCEDURE DateTime (Var Day,Mon,Year,Hrs,Min,Sec:Byte);

{ CP/M 3.0 time and date are taken from system clock through BDOS-call }
{ Refer to Weitkunat/Buehrer, c't # 5/86, included using INLINER.COM   }

  Begin
    Inline (          { ;------ DATUM.MAC --- CP/M-Plus Utility ---------- }

    $0E/$69/          { START:  LD C,105        ; get date                 }
    $11/*+96/         {         LD DE,DAYC      ; and time from            }
    $CD/$05/$00/      {         CALL 0005       ; CP/M-Plus                }
                      {                                                    }
                      { ; First process time ...                           }
                      {                                                    }
    $2A/SEC/          {         LD HL,(SEC)     ; seconds to A             }
    $CD/*+104/        {         CALL BCD                                   }
    $11/*+86/         {         LD DE,TIME                                 }
    $1A/              {         LD A,(DE)       ; hours to A               }
    $2A/HRS/          {         LD HL,(HRS)                                }
    $CD/*+94/         {         CALL BCD                                   }
    $13/              {         INC DE                                     }
    $1A/              {         LD A,(DE)       ; minutes to A             }
    $2A/MIN/          {         LD HL,(MIN)                                }
    $CD/*+86/         {         CALL BCD                                   }
                      {                                                    }
                      { ;  ... and now the date.                           }
                      {                                                    }
    $ED/$5B/*+65/     {         LD DE,(DAYC)    ; DE = days since 1.1.1978 }
    $3E/$4D/          {         LD A,77                                    }
    $2A/YEAR/         {         LD HL,(YEAR)    ; year = 78 - 1            }
    $77/              {         LD (HL),A                                  }
    $06/$00/          {         LD B,00         ; clear B                  }
    $3E/$01/          {         LD A,01         ; leap-year Counter = 1    }
                      {                         ; if 0, then leap-year !   }
                      {                                                    }
                      { ; One loop for every new year                      }
                      {                                                    }
    $2A/YEAR/         { NXTY:   LD HL,(YEAR)    ; year = year + 1          }
    $34/              {         INC (HL)                                   }
    $3C/              {         INC A           ; leap-year Counter :      }
    $E6/$03/          {         AND 3           ;  A = (A+1) MOD 4         }
    $21/*+49/         {         LD HL,MONTAB                               }
                      {                                                    }
                      { ; One loop for every new month                     }
                      {                                                    }
    $4E/              { NXTM:   LD C,(HL)       ; value from table         }
    $23/              {         INC HL                                     }
    $0C/              {         INC C           ; if 0FFh, then            }
    $28/$F1/          {         JR Z,NXTY       ;  end of year             }
    $0D/              {         DEC C           ; if 00h, then february    }
    $20/$06/          {         JR NZ,SUBTR                                }
    $0E/$1C/          {         LD C,28         ; either 28                }
    $B7/              {         OR A            ; or 29 days               }
    $20/$01/          {         JR NZ,SUBTR                                }
    $0C/              {         INC C                                      }
    $EB/              { SUBTR:  EX DE,HL        ; subtract for trial,      }
    $B7/              {         OR A            ; if less or equal zero,   }
    $ED/$42/          {         SBC HL,BC       ; then month found         }
    $EB/              {         EX DE,HL        ; and rest = day,          }
    $28/$02/          {         JR Z,READY                                 }
    $30/$E9/          {         JR NC,NXTM      ; else next month          }
    $EB/              { READY:  EX DE,HL                                   }
    $09/              {         ADD HL,BC       ; add again                }
    $7D/              {         LD A,L                                     }
    $2A/DAY/          {         LD HL,(DAY)     ; and in day               }
    $77/              {         LD (HL),A                                  }
    $EB/              {         EX DE,HL                                   }
    $11/*+15/         {         LD DE,MONTAB    ;                          }
    $B7/              {         OR A            ;                          }
    $ED/$52/          {         SBC HL,DE       ;                          }
    $7D/              {         LD A,L          ;                          }
    $2A/MON/          {         LD HL,(MON)     ;                          }
    $77/              {         LD (HL),A                                  }
    $C9/              {         RET                                        }
    $00/$00/          { DAYC:   DW 0            ; CP/M - Date              }
    $00/$00/          { TIME:   DW 0            ; CP/M - Hours and minutes }
    $1F/$00/$1F/$1E/  { MONTAB: DB 31,00,31,30                             }
    $1F/$1E/$1F/$1F/  {         DB 31,30,31,31                             }
    $1E/$1F/$1E/$1F/  {         DB 30,31,30,31                             }
    $FF/              {         DB 0FFh                                    }
                      {                                                    }
    $77/              { BCD:    LD (HL),A       ; BCD to binary            }
    $AF/              {         XOR A           ; rewrite accumulator      }
    $ED/$67/          {         RRD             ; separate Nibble          }
    $4F/              {         LD C,A          ; C = ones, (HL) = tens    }
    $7E/              {         LD A,(HL)       ; tens in accumulator      }
    $CB/$26/          {         SLA (HL)        ; (HL) = (HL) * 2          }
    $CB/$26/          {         SLA (HL)        ;  *4                      }
    $86/              {         ADD A,(HL)      ;  *5                      }
    $CB/$27/          {         SLA A           ;  *10                     }
    $81/              {         ADD A,C         ;  + ones                  }
    $77/              {         LD (HL),A                                  }
    $C9/              {         RET                                        }
    $00)
  end; { of DateTime }


function convert (wert : byte) : byte;
  begin
    convert := wert div 16 * 10 + wert mod 16;
  end;

{
procedure time;
  begin
    datetime(Day,Mon,Year,Hrs,Min,Sec);
    writeln (Hrs:2,':',Min:2,':',Sec:2)
  end;
}

function time : real;
  var h,m,s,hs : byte;
  begin
    datetime(Day,Mon,Year,Hrs,Min,Sec);
    h := hrs;
    m := min;
    s := sec;
    hs:= 0;
    time := h * 3600.0 + m * 60 + s + hs / 100;
  end;

procedure result;
begin
  td := te-ta;
  writeln;
  writeln('Dauer: ',td:12:2,' s');
  rate := anz_byte/td;
  write('Anzahl Byte: ',anz_byte:8:0);
  writeln('  ==>  Transferrate: ',rate:5:0,' Byte/s');
end;

procedure ask;
begin
  writeln;
  write('Wie viele 32-KB Bloecke schreiben?: ');
  read(an_bloeck);
  writeln;
  write('Ziellaufwerk [A...P]?: ');
  readln(drv_path);
  drv_path := drv_path + ':';
  anz_byte := laen * an_saet * an_bloeck;
end;

begin {main}
  laen := laenge;
  an_saet := anzahl_saetze;
  an_bloeck := anzahl_bloecke;
  anz_byte := laen * an_saet * an_bloeck;
  drv_path := ' ';
  {clrscr;}
  writeln(vers);
  writeln;
  write('Das Programm wird jetzt',anz_byte:8:0);
  writeln(' Bytes ins aktuelle Verzeichnis schreiben.');
  writeln;
  write('Ist das ok ? (J/N) ');
  readln(antwort);
  if not ((antwort='j') or (antwort='J')) then ask;
  filename := (drv_path+'TRANS5.DAT');
  assign(datei,filename);
  rewrite(datei);
  for j := 1 to anzahl_saetze do
  begin
    for i := 1 to laenge do
    begin
      puffer [i,j] := 1;
    end;
  end;
  writeln;
  writeln('Start schreiben, Bloecke:');
  ta := time;
  for j := 1 to an_bloeck do
  begin
    blockwrite (datei,puffer,anzahl_saetze);
    write(j);
  end;
  close(datei);
  te := time;
  result;
  reset(datei);
  writeln;
  writeln('Start lesen, Bloecke:');
  ta := time;
  for j := 1 to an_bloeck do
  begin
    blockread (datei,puffer,anzahl_saetze);
    write(j);
  end;
  close(datei);
  te := time;
  result;
  writeln;
  write('Die',anz_byte:8:0,' Byte ');
  write('grosse Testdatei gleich loeschen? (J/N) : ');
  readln(antwort);
  if ((antwort='j') or (antwort='J')) then
    erase(datei);
end.
